io.undertow.conduits

## Class FinishableStreamSinkConduit

- java.lang.Object
- - org.xnio.conduits.AbstractConduit<D>
  - - org.xnio.conduits.AbstractSinkConduit<D>
    - - org.xnio.conduits.AbstractStreamSinkConduit<org.xnio.conduits.StreamSinkConduit>
      - - io.undertow.conduits.FinishableStreamSinkConduit

All Implemented Interfaces:
  org.xnio.conduits.Conduit, org.xnio.conduits.SinkConduit, org.xnio.conduits.StreamSinkConduit

    public final class FinishableStreamSinkConduit
    extends org.xnio.conduits.AbstractStreamSinkConduit<org.xnio.conduits.StreamSinkConduit>

Author:
  David M. Lloyd

### Field Summary

### Fields inherited from class org.xnio.conduits.AbstractConduit

`next`

### Constructor Summary

Constructors
Constructor and Description
`FinishableStreamSinkConduit(org.xnio.conduits.StreamSinkConduit delegate, ConduitListener<? super FinishableStreamSinkConduit> finishListener)`

### Method Summary

All Methods Instance Methods Concrete Methods
`boolean` `flush()`
`void` `terminateWrites()`
`void` `truncateWrites()`
`int` `writeFinal(ByteBuffer src)`
`long` `writeFinal(ByteBuffer[] srcs, int offset, int length)`

### Methods inherited from class org.xnio.conduits.AbstractStreamSinkConduit

`transferFrom, transferFrom, write, write`

### Methods inherited from class org.xnio.conduits.AbstractSinkConduit

`awaitWritable, awaitWritable, getWriteThread, isWriteResumed, isWriteShutdown, resumeWrites, setWriteReadyHandler, suspendWrites, wakeupWrites`

### Methods inherited from class org.xnio.conduits.AbstractConduit

`getWorker`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.xnio.conduits.SinkConduit

`awaitWritable, awaitWritable, getWriteThread, isWriteResumed, isWriteShutdown, resumeWrites, setWriteReadyHandler, suspendWrites, wakeupWrites`

### Methods inherited from interface org.xnio.conduits.Conduit

`getWorker`

### Constructor Detail

#### FinishableStreamSinkConduit

    public FinishableStreamSinkConduit(org.xnio.conduits.StreamSinkConduit delegate,
                                       ConduitListener<? super FinishableStreamSinkConduit> finishListener)

### Method Detail

#### writeFinal

    public int writeFinal(ByteBuffer src)
                   throws IOException

Specified by:
  `writeFinal` in interface `org.xnio.conduits.StreamSinkConduit`
Overrides:
  `writeFinal` in class `org.xnio.conduits.AbstractStreamSinkConduit<org.xnio.conduits.StreamSinkConduit>`
Throws:
  `IOException`

#### writeFinal

    public long writeFinal(ByteBuffer[] srcs,
                           int offset,
                           int length)
                    throws IOException

Specified by:
  `writeFinal` in interface `org.xnio.conduits.StreamSinkConduit`
Overrides:
  `writeFinal` in class `org.xnio.conduits.AbstractStreamSinkConduit<org.xnio.conduits.StreamSinkConduit>`
Throws:
  `IOException`

#### terminateWrites

    public void terminateWrites()
                         throws IOException

Specified by:
  `terminateWrites` in interface `org.xnio.conduits.SinkConduit`
Overrides:
  `terminateWrites` in class `org.xnio.conduits.AbstractSinkConduit<org.xnio.conduits.StreamSinkConduit>`
Throws:
  `IOException`

#### truncateWrites

    public void truncateWrites()
                        throws IOException

Specified by:
  `truncateWrites` in interface `org.xnio.conduits.SinkConduit`
Overrides:
  `truncateWrites` in class `org.xnio.conduits.AbstractSinkConduit<org.xnio.conduits.StreamSinkConduit>`
Throws:
  `IOException`

#### flush

    public boolean flush()
                  throws IOException

Specified by:
  `flush` in interface `org.xnio.conduits.SinkConduit`
Overrides:
  `flush` in class `org.xnio.conduits.AbstractSinkConduit<org.xnio.conduits.StreamSinkConduit>`
Throws:
  `IOException`